/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.web.ui.internal.common.viewer.plan.gadgets.GroupInfoGadget");

dojo.require("com.ibm.jdojo.lang.Runtime");
dojo.require("com.ibm.team.apt.api.client.IPlanItem");
dojo.require("com.ibm.team.apt.api.common.IUIItem");
dojo.require("com.ibm.team.apt.shared.ui.structure.ScheduleGroupElement");
dojo.require("com.ibm.team.apt.web.client.BidiUtil");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.ViewEntryTwistie");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.gadgets.ViewportChangeHandler");
dojo.require("com.ibm.team.rtc.foundation.api.ui.tags.PrimaryLocationTag");
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.AbstractWidgetHTMLGadget");
dojo.require("dojo.i18n");
dojo.require("dojo.string");

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal.common.viewer.plan", "Messages");

(function() {
var Messages= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal.common.viewer.plan", "Messages");

var jdojo= com.ibm.jdojo.lang.Runtime;
var team= com.ibm.team;
var apt= team.apt;
var api= apt.api;
var IPlanItem= api.client.IPlanItem;
var IUIItem= api.common.IUIItem;
var ScheduleGroupElement= apt.shared.ui.structure.ScheduleGroupElement;
var web= apt.web;
var BidiUtil= web.client.BidiUtil;
var plan= web.ui.internal.common.viewer.plan;
var ViewEntryTwistie= plan.board.ViewEntryTwistie;
var ViewportChangeHandler= plan.gadgets.ViewportChangeHandler;
var foundation= team.rtc.foundation;
var PrimaryLocationTag= foundation.api.ui.tags.PrimaryLocationTag;
var AbstractWidgetHTMLGadget= foundation.web.ui.gadgets.AbstractWidgetHTMLGadget;
var string= dojo.string;

/**
 * This is the IHTMLGadget version of GroupInfoCell.
 */
var GroupInfoGadget= dojo.declare("com.ibm.team.apt.web.ui.internal.common.viewer.plan.gadgets.GroupInfoGadget", AbstractWidgetHTMLGadget, {

	//fGroupEntry: null,

	//fBoard: null,

	//fTwistie: null,

	//fOpenCount: null,

	//fClosedCount: null,

	//fImgSrc: null,

	//fImgContainerNode: null,

	//fListenerHandle: null,

	//handleViewportChange: null,

	constructor: function(parameters) {
		this.fOpenCount= 0;
		this.fClosedCount= 0;
		this.fGroupEntry= parameters.groupEntry;
		this.fBoard= parameters.board;
	},

	postCreate: function() {
		dojo.addClass(this.domNode, GroupInfoGadget.CLASS_NAME);
		this.setupTwistie(this.isGroupEmpty());
		this.readCounts();
		dojo.addClass(this.domNode, "info");
		var element= this.fGroupEntry.getElement();
		var uiItem= element.getAdapter(IUIItem);
		var labelContainer= dojo.create("div", {className: "labelContainer"}, this.domNode);
		if (jdojo.implementsInterface(uiItem, "com.ibm.team.apt.api.common.repository.IContributor")) {
			dojo.addClass(labelContainer, GroupInfoGadget.PHOTO_LABEL_CLASS);
			this.fImgContainerNode= dojo.create("div", {className: GroupInfoGadget.PHOTO_PLACEHOLDER_CLASSES}, labelContainer);
			this.fImgSrc= uiItem.getPhotoUri();
			this.fListenerHandle= ViewportChangeHandler.addListener(dojo.hitch(this, this.handleViewportChange));
			window.setTimeout(dojo.hitch(this, function() {
				this.addImageIfVisible(this.fImgContainerNode);
			}), GroupInfoGadget.DEFAULT_DELAY);
		}
		var labelContent= dojo.create("div", {className: GroupInfoGadget.LABEL_CONTENT_CLASS}, labelContainer);
		var title= dojo.create("div", {className: "title"}, labelContent);
		if (jdojo.implementsInterface(uiItem, "com.ibm.team.apt.api.common.process.IIteration")) {
			var subTitle= dojo.create("span", null, title);
			dojo.place(dojo.doc.createTextNode(element.getLabel()), subTitle);
			dojo.place(dojo.doc.createTextNode(BidiUtil.getSegmentSeparator()), title);
			var titleDetails= dojo.create("span", {className: "details"}, title);
			dojo.place(dojo.doc.createTextNode(uiItem.getDatesLabel()), titleDetails);
		} else {
			dojo.place(dojo.doc.createTextNode(element.getLabel()), title);
		}
		var counts= dojo.create("div", {className: "counts"}, labelContent);
		var itemCountMessage= string.substitute(Messages.GroupInfoCell_ITEM_COUNTS, [this.fClosedCount , this.fOpenCount]);
		if (this.fGroupEntry.getElement() instanceof ScheduleGroupElement) {
			itemCountMessage= string.substitute(Messages.GroupInfoCell_ITEM_COUNTS_TOTAL, [this.fClosedCount + this.fOpenCount ]);
		}
		dojo.place(dojo.doc.createTextNode(itemCountMessage), counts);
	},

	getBoard: function() {
		return this.fBoard;
	},

	getTwistie: function() {
		return this.fTwistie;
	},

	setupTwistie: function(isGroupEmpty) {
		this.fTwistie= new ViewEntryTwistie({fViewEntry: this.fGroupEntry, fViewer: this.fGroupEntry.getModel().getViewer()});
		this.fTwistie.setParent(this.fBoard);
		dojo.place(this.fTwistie.getHTMLElement(), this.domNode);
		if (!isGroupEmpty) {
			dojo.addClass(this.domNode, GroupInfoGadget.NON_EMPTY_GROUP_CLASS);
			this.own(this.connect(this.domNode, 'click', dojo.hitch(this, function(event) {
				this.fTwistie.setGadgetValue(!this.fTwistie.getGadgetValue());
				ViewportChangeHandler.notifyViewportHasChanged();
			})));
			this.own(this.connect(this.fTwistie.domNode, 'click', function(event) {
				ViewportChangeHandler.notifyViewportHasChanged();
			}));
			this.fTwistie.refreshGadget();
		}
	},

	isGroupEmpty: function() {
		return this.fGroupEntry.getModel().readModel(dojo.hitch(this, function(readAccessor) {
			return (readAccessor.getEntryNavigator(true).childEntries(this.fGroupEntry).length == 0);
		}));
	},

	readCounts: function() {
		this.fGroupEntry.getModel().readModel(dojo.hitch(this, function(readAccessor) {
			readAccessor.accept(dojo.hitch(this, function(entry) {
				var element= entry.getElement();
				if (entry.hasTag(PrimaryLocationTag.INSTANCE) && jdojo.implementsInterface(element, "com.ibm.team.apt.api.client.IPlanElement")) {
					if (element.getAttributeValue(IPlanItem.RESOLVED)) {
						this.fClosedCount++;
					} else {
						this.fOpenCount++;
					}
				}
				return true;
			}), this.fGroupEntry);
			return null;
		}));
	},

	getViewEntry: function() {
		return this.fGroupEntry;
	},

	handleViewportChange: function(unused) {
		this.addImageIfVisible(this.fImgContainerNode);
	},

	addImageIfVisible: function(imageContainerNode) {
		if (!ViewportChangeHandler.isNodeVisible(imageContainerNode)) {
			return ;
		}
		if (this.fListenerHandle != null && !imageContainerNode.hasChildNodes()) {
			dojo.removeClass(imageContainerNode, GroupInfoGadget.PHOTO_PLACEHOLDER_CLASS);
			dojo.create("img", {src: this.fImgSrc, className: GroupInfoGadget.PHOTO_CLASS}, imageContainerNode);
			ViewportChangeHandler.removeListener(this.fListenerHandle);
			this.fListenerHandle= null;
		}
		return ;
	},

	destroy: function(preserveDOM) {
		if (this.fListenerHandle != null) {
			ViewportChangeHandler.removeListener(this.fListenerHandle);
			this.fListenerHandle= null;
		}
		this.inherited("destroy", arguments, [preserveDOM]);
	}
});

GroupInfoGadget.CLASS_NAME= "com-ibm-team-apt-web-ui-internal-common-viewer-plan-gadgets-GroupInfoGadget";
GroupInfoGadget.DEFAULT_DELAY= 350;
GroupInfoGadget.NON_EMPTY_GROUP_CLASS= "nonEmpty";
GroupInfoGadget.PHOTO_CLASS= "photo";
GroupInfoGadget.PHOTO_PLACEHOLDER_CLASS= "photoPlaceholder";
GroupInfoGadget.PHOTO_PLACEHOLDER_CLASSES= "photoContainer photoPlaceholder";
GroupInfoGadget.LABEL_CONTENT_CLASS= "labelContent";
GroupInfoGadget.PHOTO_LABEL_CLASS= "photoLabel";

})();
